Unit tde51e_p;
interface
uses
SysUtils, Math, { Delphi }
Lstruct, Lfunc, UtRes_p, FDE51E_p, DE51E_p;

function tde51e: String;

implementation

function tde51e: String;
var
NX,IMAX,IDER,I,N,IK,IERR :Integer;
XN,XK,EPS,H,X :Extended;
CN :Array [0..2] of Extended;
CK :Array [0..2] of Extended;
YX :Array [0..149] of Extended;
DELTY :Array [0..149] of Extended;
RAB :Array [0..1649] of Extended;
Y :Array [0..149] of Extended;
YR :Array [0..199] of Extended;
label
_1,_2;
begin
Result := '';  {   }
NX := 150;
XN := 0.e0;
XK := 3.14159265358979323846264e0;
XK := XK/2.e0;
CN[0] := 2.e0;
CN[1] := -1.e0;
CN[2] := 0.e0;
CK[0] := 1.e0;
CK[1] := 1.e0;
CK[2] := -1.e0;
IMAX := 4;
EPS := 0.00001e0;
IDER := 1;
for I:=1 to NX do
 begin
  YX[I-1] := 1.5e0;
_1:
 end;
DE51E(FDE51E,NX,XN,XK,CN,CK,EPS,IMAX,IDER,YX,IK,DELTY,RAB,IERR);
Result := Result + Format('%s',['     IK']);
Result := Result + Format('%8d ',[IK]) + #$0D#$0A;
Result := Result + Format('%s',[' IERR=']);
Result := Result + Format('%3d ',[IERR]) + #$0D#$0A;
N := NX-1;
H := (XK-XN)/(N);
X := XN-H;
for I:=1 to NX do
 begin
  X := X+H;
  Y[I-1] := Sin(X)+2.e0*Cos(X);
  YR[I-1] := YX[I-1]-Y[I-1];
  Result := Result + Format(' %20.16f %20.16f %20.16f %20.16f ',
 [X,YX[I-1],Y[I-1],YR[I-1]]) + #$0D#$0A;
_2:
 end;
UtRes('tde51e',Result);  {     tde51e.res }
exit;
end;

end.
